// ゴーストの追跡行動を可能にするために、ダイクストラ法による各セル間の最小経路を求めた。
// そのために用いた関数群である。
// ダイクストラ法による経路探索には時間がかかるため、前もって探索しておいた結果をjsonとして保存し、それを用いてゴーストの意思決定を行っている。
// そのため、これらの関数群が実際にゲーム中で呼び出されることはない。

function makeRouteMap(map){
  map.forEach(function(d,i){
    var y = i;
    d.forEach(function(d,i){
      if(d != 1){
        routeMap[y + "," + i] = Dijkstra(map,y + "," + i);
      }
    });
  });
};

function evaluateDanger(pacman,ghosts){
  var danger = 0;
  var pacPosition = pacman.y + "," + pacman.x;
  ghosts.forEach(function(d){
    var ghostPosition = d.y + "," + d.x;
    if(routeMap[pacPosition][ghostPosition] != undefined){
      danger += routeMap[pacPosition][ghostPosition].cost;
    }
  });
  console.log(danger);
  return danger;
}

// goalは"y,x"の形で与える。goal[y,x]にしてそのマスを参照できるようにしてね。
function Dijkstra(map,goal){
  // console.log(map);
  console.log(goal);
  var route = {};
  var visited = [];
  route[goal] = {cost:0,from:"none"};
  var current = goal;
  while(Object.keys(route).length < fullScore/10){
    var close = Object.keys(route)
                      .filter(function(d){
                        return visited.indexOf(d) == -1;
                      })
                      .map(function(d){return route[d].cost});
    var close_node = Object.keys(route)
                      .filter(function(d){
                        return visited.indexOf(d) == -1;
                      })
                      .map(function(d){return d});
    if(close.length > 1){
      close.splice(close.indexOf(0),1);
      var current = close_node[close.indexOf(Math.min.apply(null,close))];
    }else{
      var current = close_node[0];
    }
    if(current == undefined){
      break;
    }
    Object.keys(direction).forEach(function(d){
      var next = nextCell(current,d).next().value;
      var nextX = parseInt(next.split(",")[1]);
      var nextY = parseInt(next.split(",")[0]);
      if(map[nextY][nextX] != 1){
        var buf_cost = route[current].cost + 1;
        if(route[next] == undefined){
          route[next] = {cost:route[current].cost+1,from:current};
        }else if(route[next].cost > buf_cost){
          route[next] = {cost:route[current].cost+1,from:current};
        }
      }
    });
    visited.push(current);
  }
  console.log(route);
  return route;
}
