// 配列のシャッフルや画面描画など、ゲーム全体のシステムを構成する関数群。
// AIそのものにはあまり関係ない。

function settingUp(pacman,ghost){
  if(map[pacman.y][pacman.x] == 2){
    score += 10;
  }else if(map[pacman.y][pacman.x] == 3){
    ghost.forEach(function(d,i){
      d.state = "ijike";
      d.stateCount = ijikeCount;
    });
  }
  map[pacman.y][pacman.x] = 0;
  map.forEach(function(d,i){
    var row = i;
    d.forEach(function(d,i){
      if(d == 1){
        var col = i;
        var shape = new createjs.Shape();
        shape.graphics.beginFill("#6565cc").drawCircle(rectSize*col + rectSize/2, rectSize*row + rectSize/2, rectSize/3);
        stage.addChild(shape);
      }else if(d == 2){
        var col = i;
        var shape = new createjs.Shape("");
        shape.graphics.beginFill("#e4e45e").drawCircle(rectSize*col + rectSize/2, rectSize*row + rectSize/2, rectSize/5);
        stage.addChild(shape);
      }else if(d == 3){
        var col = i;
        var shape = new createjs.Shape();
        shape.graphics.beginFill("rgb(219, 134, 107)").drawCircle(rectSize*col + rectSize/2, rectSize*row + rectSize/2, rectSize/2);
        stage.addChild(shape);
      }
    });
  });
  var pacimg = _bitmaps["pac"+pacman.move];
  pacimg.x = pacman.x * rectSize;
  pacimg.y = pacman.y * rectSize;
  pacimg.scaleX = bitmapScale;
  pacimg.scaleY = bitmapScale;
  stage.addChild(pacimg);
  ghost.forEach(function(d,i){
    if(d.state == "ijike"){
      var bitmap = _bitmaps["ijike"+i];
    }else{
      var bitmap = _bitmaps["ghost"+i];
    }
    bitmap.x = d.x * rectSize;
    bitmap.y = d.y * rectSize;
    bitmap.scaleX = bitmapScale;
    bitmap.scaleY = bitmapScale;
    stage.addChild(bitmap);
  });
};

function CollisionDetection(pacman,ghost){
  if(pacman.x == ghost.x && pacman.y == ghost.y) {return true;}
  else if(pacman.nextPosition().toString() == ghost.currentPosition.toString() && pacman.currentPosition.toString() == ghost.nextPosition().toString()){return true;}
  else{return false}
}

function consoleView(map, pacman, ghost){
  console.log("now------------------");
  var view = mapCopy(map);
  view[pacman.y][pacman.x] = "C";
  ghost.forEach(function(d){
    view[d.y][d.x] = "#";
  });
  view.forEach(function(d,i){
    console.log(i.toString(),"\t",d.toString());
  });
};

function arrAverage(arr){
  var sum = 0;
  for(var i=0; i<arr.length; i++){
    sum += arr[i];
  }
  return sum/(arr.length);
}


function mapCopy(arr){
  var copy = [];
  arr.forEach(function(d,i){
    copy.push(d.slice(0));
  });
  return copy;
}

var goodShuffle = function (arr) {
  var i, j, temp;
  arr = arr.slice();
  i = arr.length;
  if (i === 0) {
    return arr;
  }
  while (--i) {
    j = Math.floor(Math.random() * (i + 1));
    temp = arr[i];
    arr[i] = arr[j];
    arr[j] = temp;
  }
  return arr;
}

function ghostmeterRectDraw(ghost,i){
  if(ghost[i].aggression != undefined){
    var html = "";
    for(var j = 0; j < ghost[i].aggression; j++){
      html += "■";
    }
    $("#ghost"+i+"Aggression").html(html);
  }
}

function ghostSetBtn(ghost,i){
  $("#ghost"+i+"AggressionMinus").on("click",function(){
    aggressionChange(ghost,i,"minus");
    ghostmeterRectDraw(ghost,i);
  });
  $("#ghost"+i+"AggressionPlus").on("click",function(){
    aggressionChange(ghost,i,"plus");
    ghostmeterRectDraw(ghost,i);
  });
}

function aggressionChange(ghost,i,mode){
  if(mode=="minus"){
    if(ghost[i].aggression > 1) ghost[i].aggression -= 1;
  }else if(mode=="plus"){
    if(ghost[i].aggression < 10) ghost[i].aggression += 1;
  }
}

function pacStatusDraw(pacman){
  if(pacman.cowardice != undefined){
    var html = "";
    for(var i = 0; i < pacman.cowardice; i++){
      html += "■";
    }
    $("#cowardice").html(html);
    $("#pacMoveMethod").html(pacman.moveMethod);
  }
}

function pacSetBtn(pacman){
  $("#pacCowardiceMinus").on("click",function(){
    cowardiceChange(pacman,"minus");
    pacStatusDraw(pacman);
  });
  $("#pacCowardicePlus").on("click",function(){
    cowardiceChange(pacman,"plus");
    pacStatusDraw(pacman);
  });
  $("#pacMethodLeft").on("click",function(){
    pacMethodChange(pacman,"left");
    pacStatusDraw(pacman);
  });
  $("#pacMethodRight").on("click",function(){
    pacMethodChange(pacman,"right");
    pacStatusDraw(pacman);
  });
}

function cowardiceChange(pacman,mode){
  if(mode == "minus"){
    if(pacman.cowardice > 1) pacman.cowardice -= 1;
  }else if(mode == "plus"){
    if(pacman.cowardice < 10) pacman.cowardice += 1;
  }
}

function pacMethodChange(pacman,mode){
  var methods = ["primitive","tree","random"];
  var currentIndex = methods.indexOf(pacman.moveMethod);
  console.log(currentIndex);
  if(mode == "left"){
    var nextIndex = (currentIndex - 1)%3;
    if(nextIndex < 0) nextIndex = 3 + nextIndex;
  }else if(mode == "right"){
    var nextIndex = (currentIndex + 1)%3;
  }
  pacman.moveMethod = methods[nextIndex];
}
